function openTab(pageName, elmnt) {
    // Hide all elements with class="tabcontent" by default */
    var i, tabcontent, tablinks;
    tabcontent = document.getElementsByClassName("tabcontent");
    tablinks = document.getElementsByClassName("tablink");

    for (i = 0; i < tabcontent.length; i++) {
        tabcontent[i].style.display = "none";
        tablinks[i].classList.remove("active");
    }
    
    // Show the specific tab content
    document.getElementById(pageName).style.display = "block";
    elmnt.classList.add("active");
}

function linkDatasetToField(detail, targetFormName, inputName) {
    let targetForm = document.getElementById(targetFormName);
    targetForm.addEventListener("populate", event => {
        let resourceField = targetForm.querySelector(`input[name="${inputName}"]`);
        if (resourceField) {
            resourceField.value = JSON.stringify({ '@id': detail.dataset.src });
            resourceField.setAttribute('value', JSON.stringify({ '@id': detail.dataset.src }));
        }
    });
}

function refreshList(formId, listId) {
    let form = document.getElementById(formId);
    form.addEventListener("save", event => {
        let list = document.getElementById(listId);
        list.dataset.src = list.dataset.src;
    }); 
}



jQuery(document).ready(function($) {     
    // Get the element with id="defaultOpen" and click on it
    document.getElementById("defaultOpen").click();

    let userAccountDataSrc = document.getElementById("user-account-picture");
    linkDatasetToField(userAccountDataSrc, 'validation-form', 'reviewer');
    linkDatasetToField(userAccountDataSrc, 'improvement-dialog-form', 'reviewer');
    linkDatasetToField(userAccountDataSrc, 'refusal-dialog-form', 'reviewer');

    refreshList("resource-creation-form", "resources-history");
    refreshList("validation-form", "pending-resources");
    refreshList("refusal-dialog-form", "pending-resources");
    refreshList("improvement-dialog-form", "pending-resources");

    const logoutButton = document.getElementById('logout-button');
    logoutButton.addEventListener('click', function() {
        window.dispatchEvent(
            new CustomEvent('requestNavigation', { detail: { route: 'splash-index' } })
        );
        document.querySelector('sib-auth').logout();
        setTimeout(function(){ location.reload(); }, 1000);
    })

    //In the entrepreneur dashboard, we set data from the display form to the hidden ones.
    let keyword_form = document.getElementById('search-by-keyword');
    keyword_form.addEventListener("populate", event => {
        let keyword_field = keyword_form.querySelector(`input[name="keyword"]`);

        console.log(keyword_field)
        let displays = document.querySelectorAll('.resource_by_step');
        displays.forEach(display => {
            console.log('display', display);
            display.addEventListener('populate', event => {
                let hidden_fields= display.querySelectorAll('hidden-widget[name="search_for_a_resource"] input')
                console.log('Hiddent fields of display:', hidden_fields);
                keyword_field.addEventListener("input", function(){
                    hidden_fields.forEach(hidden_field => {
                        hidden_field.setAttribute("value", keyword_field.value)
                        console.log(hidden_fields)
                        console.log("element.value", hidden_field.value)
                        console.log("keyword_field.value", keyword_field.value)
                    }); 
                });
            });

            let hidden_fields= display.querySelectorAll('hidden-widget[name="search_for_a_resource"] input')
            console.log('Hiddent fields of display:', hidden_fields);
            keyword_field.addEventListener("input", function(){
                hidden_fields.forEach(hidden_field => {
                    hidden_field.setAttribute("value", keyword_field.value)
                    console.log(hidden_fields)
                    console.log("element.value", hidden_field.value)
                    console.log("keyword_field.value", keyword_field.value)
                }); 
            });
        });     
    });
 });